module Specular::Integration
  INTEGRATIONS = { }

  def self.for(name, context)
    integration = INTEGRATIONS[name]

    integration.new(
      **integration.extract_args(context)
    )
  end

  class Base
    def self.handler(*names)
      names.each do |name|
        INTEGRATIONS[name] = self
      end
    end

    def self.arguments(*args)
      define_singleton_method(:extract_args) do |context|
        args.to_h do |arg|
          [ arg, context[arg] ]
        end
      end
    end
  end
end

Dir.glob(File.expand_path('integration/*.rb', __dir__)).each do |path|
  require path
end
