require 'slack-ruby-client'

class Specular::Integration::Slack < Specular::Integration::Base
  handler :slack
  arguments :slack_token, :slack_channel

  def initialize(slack_token:, slack_channel:)
    @slack_token = slack_token
    @slack_channel = slack_channel

    Slack::Web::Client.configure do |config|
      config.token = slack_token
    end

    @client = Slack::Web::Client.new
  end

  def post_message!(message:)
    @client.chat_postMessage(
      channel: @slack_channel,
      text: message
    )
  end
end
